BackgroundPositionShorthand.Maker (Apache FOP Core 2.11 API)
Date: 2025-04-24

org.apache.fop.fo.properties

## Class BackgroundPositionShorthand.Maker

- java.lang.Object
- - org.apache.fop.fo.properties.PropertyMaker
  - - org.apache.fop.fo.properties.ListProperty.Maker
    - - org.apache.fop.fo.properties.BackgroundPositionShorthand.Maker

- All Implemented Interfaces:
    Cloneable
  Enclosing class:
    BackgroundPositionShorthand

      public static class BackgroundPositionShorthand.Maker
      extends ListProperty.Maker

  Inner class for creating instances of this property

- - ### Property Summary

    - ### Properties inherited from class org.apache.fop.fo.properties.PropertyMaker

      `makeNewProperty`

  - ### Field Summary

    - ### Fields inherited from class org.apache.fop.fo.properties.PropertyMaker

      `contextDep, corresponding, defaultProperty, defaultValue, propId, setByShorthand`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Maker(int propId)` Construct an instance of a Maker for the given property.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `PercentBase` | `getPercentBase(PropertyList pl)` This is used to handle properties specified as a percentage of some "base length", such as the content width of their containing box.
    `Property` | `make(PropertyList propertyList, String value, FObj fo)` Create a Property object from an attribute specification.

    - ### Methods inherited from class org.apache.fop.fo.properties.ListProperty.Maker

      `convertProperty`

    - ### Methods inherited from class org.apache.fop.fo.properties.PropertyMaker

      `addEnum, addKeyword, addShorthand, addSubpropMaker, checkEnumValues, checkValueKeywords, clone, compute, convertPropertyDatatype, convertShorthandProperty, findProperty, get, getName, getPropId, getShorthand, getSubprop, getSubpropMaker, isInherited, make, make, makeNewProperty, setByShorthand, setCorresponding, setDatatypeParser, setDefault, setDefault, setInherited, setPercentBase, setSubprop, useGeneric`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Maker

          public Maker(int propId)

      Construct an instance of a Maker for the given property.
      Parameters:
        `propId` - The Constant ID of the property to be made.

  - ### Method Detail

    - #### make

          public Property make(PropertyList propertyList,
                               String value,
                               FObj fo)
                        throws PropertyException

      Create a Property object from an attribute specification. If only `background-position-horizontal` is specified, `background-position-vertical` is set to "50%".
      Overrides:
        `make` in class `PropertyMaker`
      Parameters:
        `propertyList` - The PropertyList object being built for this FO.
        `value` - The attribute value.
        `fo` - The parent FO for the FO whose property is being made.
      Returns:
        The initialized Property object.
      Throws:
        `PropertyException` - for invalid or inconsistent FO input

    - #### getPercentBase

          public PercentBase getPercentBase(PropertyList pl)

      This is used to handle properties specified as a percentage of some "base length", such as the content width of their containing box. Overridden by subclasses which allow percent specifications. See the documentation on properties.xsl for details. Returns a `PercentBase` whose `getDimension()` returns 1.
      Overrides:
        `getPercentBase` in class `PropertyMaker`
      Parameters:
        `pl` - the PropertyList containing the property. (TODO: explain what this is used for, or remove it from the signature.)
      Returns:
        an object implementing the PercentBase interface.

Copyright © 2025 Apache Software Foundation. All rights reserved.